;; Winston C. Yang
;; winston@cs.wisc.edu
;; Modified 2001-10-10
;; Modified 2001-09-15
;; Modified 2001-09-06
;; Modified 2001-07-03
;; Created  2001-06-08

;; Do syntax coloring for GAMS files edited by Emacs, using regular
;; expressions. This is a quick hack; there are a few bugs: an
;; underscore followed by a keyword is not recognized as an
;; identifier, and there might be some trouble in processing large
;; files.

;;---------------------------------------------------------------------------
;; define GAMS lst mode
(define-derived-mode gams-lst-mode
  text-mode "gams-lst"
  "Major mode for reading gams lst files. Email Winston C. Yang at
winston@cs.wisc.edu

\\{gams-lst-mode-map}")

(add-hook 'gams-lst-mode-hook 'turn-on-font-lock)

;;---------------------------------------------------------------------------
;; Messages from solver.
(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(Optimal solution found\.\\)"
    1 font-lock-warning-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(^Objective.*\\)"
    1 font-lock-warning-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(Problem unbounded\.\\)"
    1 font-lock-warning-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(Presolve found the problem infeasible or unbounded\.\\)"
    1 font-lock-warning-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(Proven optimal solution\.\\)"
    1 font-lock-warning-face t)))

;;---------------------------------------------------------------------------
;; Copy of gams code in lst file.
(font-lock-add-keywords
 'gams-lst-mode
 '(("^[ ][ ]?[ ]?[ ]?\\([0-9]+[ ][ ].*\\)"
    1 font-lock-builtin-face t)))

;;---------------------------------------------------------------------------
;; Some lines begin with 4 asterisks (****).
(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(^[*][*][*][*] OBJECTIVE VALUE.*\\)"
    1 font-lock-warning-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(^[*][*][*][*].*\\)"
    1 font-lock-comment-face t)))
;;---------------------------------------------------------------------------
;; Related comments
(font-lock-add-keywords
 'gams-lst-mode
 '(("^[ ]+\\(.*INFEASIBLE\\)"
    1 font-lock-comment-face t)))

(font-lock-add-keywords
 'gams-lst-mode
 '(("^[ ]+\\(.*UNBOUNDED\\)"
    1 font-lock-comment-face t)))

;;---------------------------------------------------------------------------
;; Variables.
(font-lock-add-keywords
 'gams-lst-mode
 '(("\\(---- VAR[ ][_0-9a-zA-Z]+\\)[ ]"
    1 font-lock-warning-face t)))

;;---------------------------------------------------------------------------
;; add gams-lst-mode to the list of major modes. A gams lst file ends
;; with `.lst'
(setq auto-mode-alist
      (append
       '(("\\.lst\\'" . gams-lst-mode))
       auto-mode-alist))
